FactoryBot/InlineAssociation:
  Exclude:
    - 'ee/spec/factories/analytics/cycle_analytics/group_stages.rb'
    - 'ee/spec/factories/geo/event_log.rb'
    - 'ee/spec/factories/merge_request_blocks.rb'
    - 'ee/spec/factories/vulnerabilities/feedback.rb'
    - 'spec/factories/atlassian_identities.rb'
    - 'spec/factories/events.rb'
    - 'spec/factories/git_wiki_commit_details.rb'
    - 'spec/factories/gitaly/commit.rb'
    - 'spec/factories/go_module_commits.rb'
    - 'spec/factories/go_module_versions.rb'
    - 'spec/factories/go_modules.rb'
    - 'spec/factories/group_group_links.rb'
    - 'spec/factories/import_export_uploads.rb'
    - 'spec/factories/notes.rb'
    - 'spec/factories/uploads.rb'
    - 'spec/factories/wiki_pages.rb'

Graphql/IDType:
  Exclude:
    - 'ee/app/graphql/ee/mutations/issues/update.rb'
    - 'app/graphql/mutations/boards/issues/issue_move_list.rb'
    - 'app/graphql/resolvers/design_management/design_at_version_resolver.rb'
    - 'app/graphql/resolvers/design_management/design_resolver.rb'
    - 'app/graphql/resolvers/design_management/designs_resolver.rb'
    - 'app/graphql/resolvers/design_management/version/design_at_version_resolver.rb'
    - 'app/graphql/resolvers/design_management/version_in_collection_resolver.rb'
    - 'app/graphql/resolvers/design_management/version_resolver.rb'
    - 'app/graphql/resolvers/design_management/versions_resolver.rb'
    - 'app/graphql/resolvers/error_tracking/sentry_detailed_error_resolver.rb'
    - 'app/graphql/resolvers/error_tracking/sentry_error_stack_trace_resolver.rb'
    - 'app/graphql/resolvers/user_merge_requests_resolver.rb'

Graphql/ResolverType:
  Exclude:
    - 'app/graphql/resolvers/base_resolver.rb'
    - 'app/graphql/resolvers/ci/jobs_resolver.rb'
    - 'app/graphql/resolvers/ci/pipeline_stages_resolver.rb'
    - 'app/graphql/resolvers/merge_requests_resolver.rb'
    - 'app/graphql/resolvers/users/group_count_resolver.rb'
    - 'ee/app/graphql/resolvers/vulnerabilities_base_resolver.rb'

Rails/SaveBang:
  Exclude:
    - 'ee/spec/controllers/projects/merge_requests_controller_spec.rb'
    - 'ee/spec/controllers/subscriptions_controller_spec.rb'
    - 'ee/spec/frontend/fixtures/analytics.rb'
    - 'ee/spec/graphql/resolvers/vulnerabilities_resolver_spec.rb'
    - 'ee/spec/initializers/fog_google_https_private_urls_spec.rb'
    - 'ee/spec/lib/analytics/merge_request_metrics_calculator_spec.rb'
    - 'ee/spec/lib/ee/gitlab/auth/ldap/sync/group_spec.rb'
    - 'ee/spec/lib/ee/gitlab/checks/push_rules/commit_check_spec.rb'
    - 'ee/spec/lib/ee/gitlab/ci/pipeline/quota/activity_spec.rb'
    - 'ee/spec/lib/gitlab/auth/ldap/access_spec.rb'
    - 'ee/spec/lib/gitlab/auth/o_auth/user_spec.rb'
    - 'ee/spec/lib/gitlab/auth/saml/user_spec.rb'
    - 'ee/spec/lib/gitlab/background_migration/fix_orphan_promoted_issues_spec.rb'
    - 'ee/spec/lib/gitlab/elastic/search_results_spec.rb'
    - 'ee/spec/lib/gitlab/email/handler/ee/service_desk_handler_spec.rb'
    - 'ee/spec/lib/gitlab/geo_spec.rb'
    - 'ee/spec/lib/gitlab/git_access_spec.rb'
    - 'ee/spec/lib/gitlab/import_export/group/relation_factory_spec.rb'
    - 'ee/spec/lib/gitlab/mirror_spec.rb'
    - 'ee/spec/mailers/notify_spec.rb'
    - 'ee/spec/migrations/fix_any_approver_rule_for_projects_spec.rb'
    - 'ee/spec/migrations/geo/migrate_ci_job_artifacts_to_separate_registry_spec.rb'
    - 'ee/spec/migrations/geo/migrate_lfs_objects_to_separate_registry_spec.rb'
    - 'ee/spec/migrations/schedule_merge_request_any_approval_rule_migration_spec.rb'
    - 'ee/spec/migrations/schedule_project_any_approval_rule_migration_spec.rb'
    - 'ee/spec/models/application_setting_spec.rb'
    - 'ee/spec/models/approval_merge_request_rule_spec.rb'
    - 'ee/spec/models/approval_project_rule_spec.rb'
    - 'ee/spec/models/burndown_spec.rb'
    - 'ee/spec/models/ci/pipeline_spec.rb'
    - 'ee/spec/models/ci/subscriptions/project_spec.rb'
    - 'ee/spec/models/ee/appearance_spec.rb'
    - 'ee/spec/models/ee/ci/job_artifact_spec.rb'
    - 'ee/spec/models/ee/protected_branch_spec.rb'
    - 'ee/spec/models/ee/protected_ref_access_spec.rb'
    - 'ee/spec/models/ee/protected_ref_spec.rb'
    - 'ee/spec/models/elasticsearch_indexed_namespace_spec.rb'
    - 'ee/spec/models/environment_spec.rb'
    - 'ee/spec/models/epic_spec.rb'
    - 'ee/spec/models/geo/project_registry_spec.rb'
    - 'ee/spec/models/geo_node_spec.rb'
    - 'ee/spec/models/geo_node_status_spec.rb'
    - 'ee/spec/models/gitlab_subscription_spec.rb'
    - 'ee/spec/models/group_spec.rb'
    - 'ee/spec/models/issue_spec.rb'
    - 'ee/spec/models/label_note_spec.rb'
    - 'ee/spec/models/lfs_object_spec.rb'
    - 'ee/spec/models/license_spec.rb'
    - 'ee/spec/models/merge_request_spec.rb'
    - 'ee/spec/models/merge_train_spec.rb'
    - 'spec/models/packages/package_spec.rb'
    - 'ee/spec/models/project_ci_cd_setting_spec.rb'
    - 'ee/spec/models/project_spec.rb'
    - 'ee/spec/models/protected_environment_spec.rb'
    - 'ee/spec/models/repository_spec.rb'
    - 'ee/spec/models/scim_identity_spec.rb'
    - 'ee/spec/models/scim_oauth_access_token_spec.rb'
    - 'ee/spec/models/upload_spec.rb'
    - 'ee/spec/models/user_preference_spec.rb'
    - 'ee/spec/models/visible_approvable_spec.rb'
    - 'ee/spec/models/vulnerabilities/feedback_spec.rb'
    - 'ee/spec/models/vulnerabilities/issue_link_spec.rb'
    - 'ee/spec/presenters/audit_event_presenter_spec.rb'
    - 'ee/spec/presenters/epic_presenter_spec.rb'
    - 'ee/spec/requests/api/boards_spec.rb'
    - 'ee/spec/requests/api/epic_issues_spec.rb'
    - 'ee/spec/requests/api/epic_links_spec.rb'
    - 'ee/spec/requests/api/epics_spec.rb'
    - 'ee/spec/requests/api/geo_nodes_spec.rb'
    - 'ee/spec/requests/api/geo_spec.rb'
    - 'ee/spec/requests/api/graphql/group/epics_spec.rb'
    - 'ee/spec/requests/api/graphql/mutations/epic_tree/reorder_spec.rb'
    - 'ee/spec/requests/api/groups_spec.rb'
    - 'ee/spec/requests/api/issues_spec.rb'
    - 'ee/spec/requests/api/ldap_group_links_spec.rb'
    - 'ee/spec/requests/api/merge_request_approval_rules_spec.rb'
    - 'ee/spec/requests/api/merge_request_approvals_spec.rb'
    - 'ee/spec/requests/api/merge_requests_spec.rb'
    - 'ee/spec/requests/api/project_approvals_spec.rb'
    - 'ee/spec/requests/api/projects_spec.rb'
    - 'ee/spec/requests/api/protected_branches_spec.rb'
    - 'ee/spec/requests/api/scim_spec.rb'
    - 'ee/spec/requests/api/todos_spec.rb'
    - 'ee/spec/requests/lfs_http_spec.rb'
    - 'ee/spec/services/approval_rules/finalize_service_spec.rb'
    - 'ee/spec/services/approval_rules/update_service_spec.rb'
    - 'ee/spec/services/ee/boards/issues/create_service_spec.rb'
    - 'ee/spec/services/ee/boards/issues/list_service_spec.rb'
    - 'ee/spec/services/ee/boards/lists/list_service_spec.rb'
    - 'ee/spec/services/ee/issuable/clone/attributes_rewriter_spec.rb'
    - 'ee/spec/services/ee/issuable/common_system_notes_service_spec.rb'
    - 'ee/spec/services/ee/issues/update_service_spec.rb'
    - 'ee/spec/services/ee/merge_requests/refresh_service_spec.rb'
    - 'ee/spec/services/ee/merge_requests/update_service_spec.rb'
    - 'ee/spec/services/ee/notes/quick_actions_service_spec.rb'
    - 'ee/spec/services/ee/notification_service_spec.rb'
    - 'ee/spec/services/epic_links/create_service_spec.rb'
    - 'ee/spec/services/epics/close_service_spec.rb'
    - 'ee/spec/services/epics/issue_promote_service_spec.rb'
    - 'ee/spec/services/epics/reopen_service_spec.rb'
    - 'ee/spec/services/epics/tree_reorder_service_spec.rb'
    - 'ee/spec/services/epics/update_dates_service_spec.rb'
    - 'ee/spec/services/epics/update_service_spec.rb'
    - 'ee/spec/services/geo/blob_verification_secondary_service_spec.rb'
    - 'ee/spec/services/geo/files_expire_service_spec.rb'
    - 'ee/spec/services/geo/metrics_update_service_spec.rb'
    - 'ee/spec/services/geo/registry_consistency_service_spec.rb'
    - 'ee/spec/services/geo/repository_verification_secondary_service_spec.rb'
    - 'ee/spec/services/groups/autocomplete_service_spec.rb'
    - 'ee/spec/services/ldap_group_reset_service_spec.rb'
    - 'ee/spec/services/lfs/unlock_file_service_spec.rb'
    - 'ee/spec/services/merge_trains/refresh_merge_request_service_spec.rb'
    - 'ee/spec/services/quick_actions/interpret_service_spec.rb'
    - 'ee/spec/services/slash_commands/global_slack_handler_spec.rb'
    - 'ee/spec/services/start_pull_mirroring_service_spec.rb'
    - 'ee/spec/services/status_page/trigger_publish_service_spec.rb'
    - 'ee/spec/services/todo_service_spec.rb'
    - 'ee/spec/services/update_build_minutes_service_spec.rb'
    - 'ee/spec/services/vulnerability_feedback/create_service_spec.rb'
    - 'ee/spec/support/protected_tags/access_control_shared_examples.rb'
    - 'ee/spec/support/shared_examples/features/protected_branches_access_control_shared_examples.rb'
    - 'ee/spec/support/shared_examples/finders/geo/framework_registry_finder_shared_examples.rb'
    - 'ee/spec/support/shared_examples/graphql/geo/geo_registries_resolver_shared_examples.rb'
    - 'ee/spec/support/shared_examples/lib/analytics/common_merge_request_metrics_refresh_shared_examples.rb'
    - 'ee/spec/support/shared_examples/policies/protected_environments_shared_examples.rb'
    - 'ee/spec/workers/adjourned_project_deletion_worker_spec.rb'
    - 'ee/spec/workers/clear_shared_runners_minutes_worker_spec.rb'
    - 'ee/spec/workers/create_github_webhook_worker_spec.rb'
    - 'ee/spec/workers/elastic_namespace_rollout_worker_spec.rb'
    - 'ee/spec/workers/geo/container_repository_sync_dispatch_worker_spec.rb'
    - 'ee/spec/workers/geo/file_download_dispatch_worker_spec.rb'
    - 'ee/spec/workers/geo/prune_event_log_worker_spec.rb'
    - 'ee/spec/workers/geo/registry_sync_worker_spec.rb'
    - 'ee/spec/workers/geo/repository_shard_sync_worker_spec.rb'
    - 'ee/spec/workers/repository_import_worker_spec.rb'
    - 'ee/spec/workers/update_all_mirrors_worker_spec.rb'
    - 'qa/qa/specs/features/browser_ui/3_create/repository/push_mirroring_over_http_spec.rb'
    - 'qa/qa/specs/features/browser_ui/3_create/repository/push_mirroring_lfs_over_http_spec.rb'
    - 'qa/qa/specs/features/ee/browser_ui/3_create/repository/pull_mirroring_over_http_spec.rb'
    - 'qa/qa/specs/features/ee/browser_ui/3_create/repository/pull_mirroring_over_ssh_with_key_spec.rb'
    - 'spec/controllers/abuse_reports_controller_spec.rb'
    - 'spec/controllers/admin/impersonations_controller_spec.rb'
    - 'spec/controllers/admin/runners_controller_spec.rb'
    - 'spec/controllers/admin/services_controller_spec.rb'
    - 'spec/controllers/boards/issues_controller_spec.rb'
    - 'spec/controllers/groups/milestones_controller_spec.rb'
    - 'spec/controllers/groups/runners_controller_spec.rb'
    - 'spec/controllers/groups/uploads_controller_spec.rb'
    - 'spec/controllers/groups_controller_spec.rb'
    - 'spec/controllers/oauth/authorizations_controller_spec.rb'
    - 'spec/controllers/omniauth_callbacks_controller_spec.rb'
    - 'spec/controllers/profiles/emails_controller_spec.rb'
    - 'spec/controllers/profiles/notifications_controller_spec.rb'
    - 'spec/controllers/projects/artifacts_controller_spec.rb'
    - 'spec/controllers/projects/cycle_analytics/events_controller_spec.rb'
    - 'spec/controllers/projects/cycle_analytics_controller_spec.rb'
    - 'spec/controllers/projects/discussions_controller_spec.rb'
    - 'spec/controllers/projects/forks_controller_spec.rb'
    - 'spec/controllers/projects/group_links_controller_spec.rb'
    - 'spec/controllers/projects/imports_controller_spec.rb'
    - 'spec/controllers/projects/issues_controller_spec.rb'
    - 'spec/controllers/projects/labels_controller_spec.rb'
    - 'spec/controllers/projects/milestones_controller_spec.rb'
    - 'spec/controllers/projects/notes_controller_spec.rb'
    - 'spec/controllers/projects/pipelines_controller_spec.rb'
    - 'spec/controllers/projects/releases/evidences_controller_spec.rb'
    - 'spec/controllers/projects/runners_controller_spec.rb'
    - 'spec/controllers/projects/starrers_controller_spec.rb'
    - 'spec/controllers/projects/uploads_controller_spec.rb'
    - 'spec/controllers/projects_controller_spec.rb'
    - 'spec/controllers/sent_notifications_controller_spec.rb'
    - 'spec/controllers/sessions_controller_spec.rb'
    - 'spec/controllers/users_controller_spec.rb'
    - 'spec/factories_spec.rb'
    - 'spec/features/admin/admin_appearance_spec.rb'
    - 'spec/features/admin/admin_labels_spec.rb'
    - 'spec/features/admin/admin_mode/login_spec.rb'
    - 'spec/features/admin/admin_runners_spec.rb'
    - 'spec/features/admin/admin_sees_project_statistics_spec.rb'
    - 'spec/features/admin/admin_sees_projects_statistics_spec.rb'
    - 'spec/features/admin/admin_users_impersonation_tokens_spec.rb'
    - 'spec/features/boards/sidebar_spec.rb'
    - 'spec/features/calendar_spec.rb'
    - 'spec/features/commits_spec.rb'
    - 'spec/features/dashboard/datetime_on_tooltips_spec.rb'
    - 'spec/features/dashboard/issuables_counter_spec.rb'
    - 'spec/features/dashboard/project_member_activity_index_spec.rb'
    - 'spec/features/dashboard/projects_spec.rb'
    - 'spec/features/error_tracking/user_sees_error_index_spec.rb'
    - 'spec/features/groups/members/request_access_spec.rb'
    - 'spec/features/issuables/close_reopen_report_toggle_spec.rb'
    - 'spec/features/issues/bulk_assignment_labels_spec.rb'
    - 'spec/features/issues/gfm_autocomplete_spec.rb'
    - 'spec/features/issues/issue_sidebar_spec.rb'
    - 'spec/features/issues/note_polling_spec.rb'
    - 'spec/features/issues/user_creates_branch_and_merge_request_spec.rb'
    - 'spec/features/issues/user_creates_confidential_merge_request_spec.rb'
    - 'spec/features/issues/user_edits_issue_spec.rb'
    - 'spec/features/issues/user_filters_issues_spec.rb'
    - 'spec/features/issues/user_sees_live_update_spec.rb'
    - 'spec/features/issues/user_sorts_issues_spec.rb'
    - 'spec/features/profiles/emails_spec.rb'
    - 'spec/features/profiles/password_spec.rb'
    - 'spec/features/profiles/personal_access_tokens_spec.rb'
    - 'spec/features/projects/features_visibility_spec.rb'
    - 'spec/features/projects/fork_spec.rb'
    - 'spec/features/projects/jobs/permissions_spec.rb'
    - 'spec/features/projects/jobs_spec.rb'
    - 'spec/features/projects/members/user_requests_access_spec.rb'
    - 'spec/features/projects/pages_lets_encrypt_spec.rb'
    - 'spec/features/projects/pages_spec.rb'
    - 'spec/features/projects/pipelines/pipeline_spec.rb'
    - 'spec/features/projects/pipelines/pipelines_spec.rb'
    - 'spec/features/projects/remote_mirror_spec.rb'
    - 'spec/features/projects/services/user_activates_slack_notifications_spec.rb'
    - 'spec/features/projects/settings/access_tokens_spec.rb'
    - 'spec/features/projects/show/user_sees_deletion_failure_message_spec.rb'
    - 'spec/features/projects/user_sees_sidebar_spec.rb'
    - 'spec/features/projects/wiki/user_updates_wiki_page_spec.rb'
    - 'spec/features/projects/wiki/user_views_wiki_page_spec.rb'
    - 'spec/features/projects/wiki/users_views_asciidoc_page_with_includes_spec.rb'
    - 'spec/features/runners_spec.rb'
    - 'spec/features/security/project/internal_access_spec.rb'
    - 'spec/features/security/project/private_access_spec.rb'
    - 'spec/features/security/project/public_access_spec.rb'
    - 'spec/features/users/login_spec.rb'
    - 'spec/features/users/show_spec.rb'
    - 'spec/frontend/fixtures/issues.rb'
    - 'spec/frontend/fixtures/merge_requests.rb'
    - 'spec/graphql/mutations/merge_requests/set_locked_spec.rb'
    - 'spec/graphql/mutations/merge_requests/set_wip_spec.rb'
    - 'spec/graphql/resolvers/boards_resolver_spec.rb'
    - 'spec/initializers/active_record_locking_spec.rb'
    - 'spec/initializers/fog_google_https_private_urls_spec.rb'
    - 'spec/lib/after_commit_queue_spec.rb'
    - 'spec/lib/backup/manager_spec.rb'
    - 'spec/lib/banzai/reference_parser/external_issue_parser_spec.rb'
    - 'spec/lib/banzai/reference_redactor_spec.rb'
    - 'spec/lib/gitlab/alerting/alert_spec.rb'
    - 'spec/lib/gitlab/analytics/cycle_analytics/records_fetcher_spec.rb'
    - 'spec/lib/gitlab/auth/ldap/user_spec.rb'
    - 'spec/lib/gitlab/auth/o_auth/user_spec.rb'
    - 'spec/lib/gitlab/auth/saml/user_spec.rb'
    - 'spec/lib/gitlab/auth_spec.rb'
    - 'spec/lib/gitlab/authorized_keys_spec.rb'
    - 'spec/lib/gitlab/background_migration/backfill_deployment_clusters_from_deployments_spec.rb'
    - 'spec/lib/gitlab/background_migration/backfill_project_repositories_spec.rb'
    - 'spec/lib/gitlab/background_migration/backfill_project_settings_spec.rb'
    - 'spec/lib/gitlab/background_migration/backfill_push_rules_id_in_projects_spec.rb'
    - 'spec/lib/gitlab/background_migration/backfill_snippet_repositories_spec.rb'
    - 'spec/lib/gitlab/background_migration/digest_column_spec.rb'
    - 'spec/lib/gitlab/background_migration/encrypt_columns_spec.rb'
    - 'spec/lib/gitlab/background_migration/fix_cross_project_label_links_spec.rb'
    - 'spec/lib/gitlab/background_migration/fix_projects_without_project_feature_spec.rb'
    - 'spec/lib/gitlab/background_migration/fix_projects_without_prometheus_service_spec.rb'
    - 'spec/lib/gitlab/background_migration/fix_user_namespace_names_spec.rb'
    - 'spec/lib/gitlab/background_migration/fix_user_project_route_names_spec.rb'
    - 'spec/lib/gitlab/background_migration/legacy_upload_mover_spec.rb'
    - 'spec/lib/gitlab/background_migration/legacy_uploads_migrator_spec.rb'
    - 'spec/lib/gitlab/background_migration/link_lfs_objects_projects_spec.rb'
    - 'spec/lib/gitlab/background_migration/migrate_issue_trackers_sensitive_data_spec.rb'
    - 'spec/lib/gitlab/background_migration/migrate_stage_index_spec.rb'
    - 'spec/lib/gitlab/background_migration/migrate_users_bio_to_user_details_spec.rb'
    - 'spec/lib/gitlab/background_migration/populate_canonical_emails_spec.rb'
    - 'spec/lib/gitlab/background_migration/populate_merge_request_assignees_table_spec.rb'
    - 'spec/lib/gitlab/background_migration/populate_user_highest_roles_table_spec.rb'
    - 'spec/lib/gitlab/background_migration/recalculate_project_authorizations_spec.rb'
    - 'spec/lib/gitlab/background_migration/remove_restricted_todos_spec.rb'
    - 'spec/lib/gitlab/background_migration/reset_merge_status_spec.rb'
    - 'spec/lib/gitlab/background_migration/set_confidential_note_events_on_services_spec.rb'
    - 'spec/lib/gitlab/background_migration/set_confidential_note_events_on_webhooks_spec.rb'
    - 'spec/lib/gitlab/bitbucket_server_import/importer_spec.rb'
    - 'spec/lib/gitlab/ci/ansi2json/style_spec.rb'
    - 'spec/lib/gitlab/ci/status/build/common_spec.rb'
    - 'spec/lib/gitlab/cycle_analytics/base_event_fetcher_spec.rb'
    - 'spec/lib/gitlab/database/custom_structure_spec.rb'
    - 'spec/lib/gitlab/database/partitioning_migration_helpers/table_management_helpers_spec.rb'
    - 'spec/lib/gitlab/database_importers/self_monitoring/project/create_service_spec.rb'
    - 'spec/lib/gitlab/email/handler/create_note_handler_spec.rb'
    - 'spec/lib/gitlab/email/handler/unsubscribe_handler_spec.rb'
    - 'spec/lib/gitlab/gfm/reference_rewriter_spec.rb'
    - 'spec/lib/gitlab/git_access_spec.rb'
    - 'spec/lib/gitlab/gitaly_client/object_pool_service_spec.rb'
    - 'spec/lib/gitlab/gitaly_client/repository_service_spec.rb'
    - 'spec/lib/gitlab/import_export/avatar_saver_spec.rb'
    - 'spec/lib/gitlab/import_export/base/relation_factory_spec.rb'
    - 'spec/lib/gitlab/import_export/design_repo_restorer_spec.rb'
    - 'spec/lib/gitlab/import_export/fast_hash_serializer_spec.rb'
    - 'spec/lib/gitlab/import_export/fork_spec.rb'
    - 'spec/lib/gitlab/import_export/group/legacy_tree_saver_spec.rb'
    - 'spec/lib/gitlab/import_export/group/relation_factory_spec.rb'
    - 'spec/lib/gitlab/import_export/group/tree_saver_spec.rb'
    - 'spec/lib/gitlab/import_export/importer_spec.rb'
    - 'spec/lib/gitlab/import_export/lfs_restorer_spec.rb'
    - 'spec/lib/gitlab/import_export/lfs_saver_spec.rb'
    - 'spec/lib/gitlab/import_export/members_mapper_spec.rb'
    - 'spec/lib/gitlab/import_export/project/relation_factory_spec.rb'
    - 'spec/lib/gitlab/import_export/project/tree_restorer_spec.rb'
    - 'spec/lib/gitlab/import_export/project/tree_saver_spec.rb'
    - 'spec/lib/gitlab/import_export/repo_restorer_spec.rb'
    - 'spec/lib/gitlab/import_export/saver_spec.rb'
    - 'spec/lib/gitlab/import_export/snippet_repo_restorer_spec.rb'
    - 'spec/lib/gitlab/import_export/snippet_repo_saver_spec.rb'
    - 'spec/lib/gitlab/import_export/snippets_repo_restorer_spec.rb'
    - 'spec/lib/gitlab/import_export/snippets_repo_saver_spec.rb'
    - 'spec/lib/gitlab/import_export/uploads_manager_spec.rb'
    - 'spec/lib/gitlab/import_export/uploads_saver_spec.rb'
    - 'spec/lib/gitlab/import_export/wiki_restorer_spec.rb'
    - 'spec/lib/gitlab/legacy_github_import/importer_spec.rb'
    - 'spec/lib/gitlab/legacy_github_import/issue_formatter_spec.rb'
    - 'spec/lib/gitlab/legacy_github_import/milestone_formatter_spec.rb'
    - 'spec/lib/gitlab/legacy_github_import/pull_request_formatter_spec.rb'
    - 'spec/lib/gitlab/lets_encrypt/client_spec.rb'
    - 'spec/lib/gitlab/markdown_cache/active_record/extension_spec.rb'
    - 'spec/lib/gitlab/markdown_cache/redis/store_spec.rb'
    - 'spec/lib/gitlab/middleware/go_spec.rb'
    - 'spec/lib/gitlab/shard_health_cache_spec.rb'
    - 'spec/lib/mattermost/command_spec.rb'
    - 'spec/lib/mattermost/session_spec.rb'
    - 'spec/lib/mattermost/team_spec.rb'
    - 'spec/mailers/notify_spec.rb'
    - 'spec/migrations/20190924152703_migrate_issue_trackers_data_spec.rb'
    - 'spec/migrations/20200122123016_backfill_project_settings_spec.rb'
    - 'spec/migrations/20200123155929_remove_invalid_jira_data_spec.rb'
    - 'spec/migrations/20200127090233_remove_invalid_issue_tracker_data_spec.rb'
    - 'spec/migrations/20200130145430_reschedule_migrate_issue_trackers_data_spec.rb'
    - 'spec/migrations/20200313203550_remove_orphaned_chat_names_spec.rb'
    - 'spec/migrations/20200406102120_backfill_deployment_clusters_from_deployments_spec.rb'
    - 'spec/migrations/20200526115436_dedup_mr_metrics_spec.rb'
    - 'spec/migrations/add_deploy_token_type_to_deploy_tokens_spec.rb'
    - 'spec/migrations/add_incident_settings_to_all_existing_projects_spec.rb'
    - 'spec/migrations/add_unique_constraint_to_approvals_user_id_and_merge_request_id_spec.rb'
    - 'spec/migrations/backfill_and_add_not_null_constraint_to_released_at_column_on_releases_table_spec.rb'
    - 'spec/migrations/backfill_imported_snippet_repositories_spec.rb'
    - 'spec/migrations/backfill_releases_table_updated_at_and_add_not_null_constraints_to_timestamps_spec.rb'
    - 'spec/migrations/backfill_snippet_repositories_spec.rb'
    - 'spec/migrations/encrypt_plaintext_attributes_on_application_settings_spec.rb'
    - 'spec/migrations/enqueue_reset_merge_status_second_run_spec.rb'
    - 'spec/migrations/enqueue_reset_merge_status_spec.rb'
    - 'spec/migrations/fill_file_store_lfs_objects_spec.rb'
    - 'spec/migrations/fill_store_uploads_spec.rb'
    - 'spec/migrations/fix_null_type_labels_spec.rb'
    - 'spec/migrations/fix_pool_repository_source_project_id_spec.rb'
    - 'spec/migrations/fix_projects_without_project_feature_spec.rb'
    - 'spec/migrations/fix_projects_without_prometheus_services_spec.rb'
    - 'spec/migrations/fix_wrong_pages_access_level_spec.rb'
    - 'spec/migrations/insert_project_hooks_plan_limits_spec.rb'
    - 'spec/migrations/migrate_auto_dev_ops_domain_to_cluster_domain_spec.rb'
    - 'spec/migrations/move_limits_from_plans_spec.rb'
    - 'spec/migrations/populate_project_statistics_packages_size_spec.rb'
    - 'spec/migrations/schedule_link_lfs_objects_projects_spec.rb'
    - 'spec/migrations/schedule_populate_merge_request_assignees_table_spec.rb'
    - 'spec/migrations/seed_repository_storages_weighted_spec.rb'
    - 'spec/models/appearance_spec.rb'
    - 'spec/models/application_record_spec.rb'
    - 'spec/models/application_setting_spec.rb'
    - 'spec/models/clusters/applications/helm_spec.rb'
    - 'spec/models/commit_spec.rb'
    - 'spec/models/commit_status_spec.rb'
    - 'spec/models/container_repository_spec.rb'
    - 'spec/models/deploy_keys_project_spec.rb'
    - 'spec/models/deploy_token_spec.rb'
    - 'spec/models/deployment_spec.rb'
    - 'spec/models/design_management/version_spec.rb'
    - 'spec/models/diff_discussion_spec.rb'
    - 'spec/models/diff_note_spec.rb'
    - 'spec/models/email_spec.rb'
    - 'spec/models/environment_spec.rb'
    - 'spec/models/event_spec.rb'
    - 'spec/models/fork_network_spec.rb'
    - 'spec/models/generic_commit_status_spec.rb'
    - 'spec/models/grafana_integration_spec.rb'
    - 'spec/models/group_spec.rb'
    - 'spec/models/hooks/system_hook_spec.rb'
    - 'spec/models/hooks/web_hook_spec.rb'
    - 'spec/models/identity_spec.rb'
    - 'spec/models/issue/metrics_spec.rb'
    - 'spec/models/issue_spec.rb'
    - 'spec/models/jira_import_state_spec.rb'
    - 'spec/models/key_spec.rb'
    - 'spec/models/lfs_objects_project_spec.rb'
    - 'spec/models/member_spec.rb'
    - 'spec/models/members/group_member_spec.rb'
    - 'spec/models/members/project_member_spec.rb'
    - 'spec/models/merge_request_spec.rb'
    - 'spec/models/milestone_spec.rb'
    - 'spec/models/namespace_spec.rb'
    - 'spec/models/note_spec.rb'
    - 'spec/models/notification_setting_spec.rb'
    - 'spec/models/operations/feature_flag_scope_spec.rb'
    - 'spec/models/operations/feature_flags/strategy_spec.rb'
    - 'spec/models/operations/feature_flags/user_list_spec.rb'
    - 'spec/models/pages_domain_spec.rb'
    - 'spec/models/project_auto_devops_spec.rb'
    - 'spec/models/project_feature_spec.rb'
    - 'spec/models/project_spec.rb'
    - 'spec/models/project_team_spec.rb'
    - 'spec/models/protectable_dropdown_spec.rb'
    - 'spec/models/redirect_route_spec.rb'
    - 'spec/models/release_spec.rb'
    - 'spec/models/remote_mirror_spec.rb'
    - 'spec/models/resource_milestone_event_spec.rb'
    - 'spec/models/route_spec.rb'
    - 'spec/models/sentry_issue_spec.rb'
    - 'spec/models/service_spec.rb'
    - 'spec/models/snippet_spec.rb'
    - 'spec/models/upload_spec.rb'
    - 'spec/models/user_preference_spec.rb'
    - 'spec/models/user_spec.rb'
    - 'spec/models/user_status_spec.rb'
    - 'spec/models/wiki_page/meta_spec.rb'
    - 'spec/models/wiki_page_spec.rb'
    - 'spec/presenters/ci/build_runner_presenter_spec.rb'
    - 'spec/presenters/ci/trigger_presenter_spec.rb'
    - 'spec/presenters/packages/conan/package_presenter_spec.rb'
    - 'spec/requests/api/ci/runner_spec.rb'
    - 'spec/requests/api/commit_statuses_spec.rb'
    - 'spec/requests/api/conan_packages_spec.rb'
    - 'spec/requests/api/deployments_spec.rb'
    - 'spec/requests/api/environments_spec.rb'
    - 'spec/requests/api/go_proxy_spec.rb'
    - 'spec/requests/api/graphql/mutations/merge_requests/set_labels_spec.rb'
    - 'spec/requests/api/graphql/user_query_spec.rb'
    - 'spec/requests/api/graphql_spec.rb'
    - 'spec/requests/api/group_import_spec.rb'
    - 'spec/requests/api/group_milestones_spec.rb'
    - 'spec/requests/api/internal/base_spec.rb'
    - 'spec/requests/api/issues/get_group_issues_spec.rb'
    - 'spec/requests/api/issues/post_projects_issues_spec.rb'
    - 'spec/requests/api/jobs_spec.rb'
    - 'spec/requests/api/labels_spec.rb'
    - 'spec/requests/api/project_import_spec.rb'
    - 'spec/requests/projects/cycle_analytics_events_spec.rb'

Rails/TimeZone:
  Enabled: true
  Exclude:
    - 'lib/gitlab/popen.rb'
    - 'ee/lib/delay.rb'
    - 'ee/lib/gitlab/elastic/helper.rb'
    - 'ee/lib/gitlab/elastic/indexer.rb'
    - 'ee/lib/gitlab/geo/base_request.rb'
    - 'ee/lib/gitlab/geo/event_gap_tracking.rb'
    - 'ee/lib/gitlab/geo/log_cursor/events/design_repository_updated_event.rb'
    - 'ee/lib/gitlab/geo/log_cursor/events/repository_updated_event.rb'
    - 'ee/lib/gitlab/geo/log_cursor/logger.rb'
    - 'ee/lib/gitlab/geo/oauth/login_state.rb'
    - 'ee/lib/gitlab/prometheus/queries/cluster_query.rb'
    - 'ee/lib/gitlab/prometheus/queries/packet_flow_query.rb'
    - 'ee/spec/lib/ee/gitlab/checks/push_rules/commit_check_spec.rb'
    - 'ee/spec/lib/ee/gitlab/ci/pipeline/quota/job_activity_spec.rb'
    - 'ee/spec/lib/gitlab/analytics/cycle_analytics/data_collector_spec.rb'
    - 'ee/spec/lib/gitlab/analytics/cycle_analytics/summary/group/stage_summary_spec.rb'
    - 'ee/spec/lib/gitlab/analytics/cycle_analytics/summary/group/stage_time_summary_spec.rb'
    - 'ee/spec/lib/gitlab/auth/ldap/access_spec.rb'
    - 'ee/spec/lib/gitlab/auth/smartcard/san_extension_spec.rb'
    - 'ee/spec/lib/gitlab/auth/smartcard/session_spec.rb'
    - 'ee/spec/lib/gitlab/background_migration/fix_orphan_promoted_issues_spec.rb'
    - 'ee/spec/lib/gitlab/ci/pipeline/chain/limit/job_activity_spec.rb'
    - 'ee/spec/lib/gitlab/elastic/client_spec.rb'
    - 'ee/spec/lib/gitlab/geo/base_request_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/cache_invalidation_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/container_repository_updated_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/design_repository_updated_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/hashed_storage_attachments_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/hashed_storage_migrated_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/job_artifact_deleted_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/lfs_object_deleted_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/repositories_changed_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/repository_created_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/repository_deleted_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/repository_renamed_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/repository_updated_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/reset_checksum_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/upload_deleted_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/logger_spec.rb'
    - 'ee/spec/lib/gitlab/git_access_spec.rb'
    - 'ee/spec/lib/gitlab/prometheus/queries/additional_metrics_deployment_query_spec.rb'
    - 'ee/spec/lib/gitlab/prometheus/queries/cluster_query_spec.rb'
    - 'ee/spec/lib/gitlab/prometheus/queries/packet_flow_query_spec.rb'
    - 'lib/api/helpers.rb'
    - 'lib/api/sidekiq_metrics.rb'
    - 'lib/backup/manager.rb'
    - 'lib/bitbucket_server/representation/base.rb'
    - 'lib/gitlab/auth/current_user_mode.rb'
    - 'lib/gitlab/auth/ldap/access.rb'
    - 'lib/gitlab/chaos.rb'
    - 'lib/gitlab/checks/timed_logger.rb'
    - 'lib/gitlab/ci/ansi2json/line.rb'
    - 'lib/gitlab/ci/pipeline/chain/sequence.rb'
    - 'lib/gitlab/ci/pipeline/duration.rb'
    - 'lib/gitlab/cycle_analytics/summary/deployment_frequency.rb'
    - 'lib/gitlab/database.rb'
    - 'lib/gitlab/external_authorization/access.rb'
    - 'lib/gitlab/external_authorization/cache.rb'
    - 'lib/gitlab/gitaly_client.rb'
    - 'lib/gitlab/gitaly_client/ref_service.rb'
    - 'lib/gitlab/github_import/representation.rb'
    - 'lib/gitlab/grape_logging/loggers/queue_duration_logger.rb'
    - 'lib/gitlab/health_checks/base_abstract_check.rb'
    - 'lib/gitlab/import_export.rb'
    - 'lib/gitlab/instrumentation/elasticsearch_transport.rb'
    - 'lib/gitlab/instrumentation/redis_interceptor.rb'
    - 'lib/gitlab/instrumentation_helper.rb'
    - 'lib/gitlab/kubernetes/helm/certificate.rb'
    - 'lib/gitlab/lfs_token.rb'
    - 'lib/gitlab/loop_helpers.rb'
    - 'lib/gitlab/phabricator_import/representation/task.rb'
    - 'lib/gitlab/prometheus/queries/additional_metrics_environment_query.rb'
    - 'lib/gitlab/prometheus/queries/matched_metric_query.rb'
    - 'lib/gitlab/prometheus_client.rb'
    - 'lib/gitlab/sherlock/transaction.rb'
    - 'lib/gitlab/task_helpers.rb'
    - 'lib/gitlab/x509/tag.rb'
    - 'lib/grafana/time_window.rb'
    - 'lib/json_web_token/token.rb'
    - 'lib/object_storage/direct_upload.rb'
    - 'lib/quality/seeders/issues.rb'
    - 'lib/rspec_flaky/flaky_example.rb'
    - 'lib/rspec_flaky/report.rb'
    - 'lib/tasks/gitlab/assets.rake'
    - 'lib/tasks/gitlab/backup.rake'
    - 'lib/tasks/gitlab/cleanup.rake'
    - 'lib/tasks/gitlab/list_repos.rake'
    - 'spec/lib/api/helpers_spec.rb'
    - 'spec/lib/gitlab/analytics/cycle_analytics/base_query_builder_spec.rb'
    - 'spec/lib/gitlab/app_json_logger_spec.rb'
    - 'spec/lib/gitlab/app_text_logger_spec.rb'
    - 'spec/lib/gitlab/auth/current_user_mode_spec.rb'
    - 'spec/lib/gitlab/background_migration/recalculate_project_authorizations_spec.rb'
    - 'spec/lib/gitlab/background_migration/wrongfully_confirmed_email_unconfirmer_spec.rb'
    - 'spec/lib/gitlab/bitbucket_import/importer_spec.rb'
    - 'spec/lib/gitlab/bitbucket_server_import/importer_spec.rb'
    - 'spec/lib/gitlab/checks/timed_logger_spec.rb'
    - 'spec/lib/gitlab/ci/cron_parser_spec.rb'
    - 'spec/lib/gitlab/cycle_analytics/stage_summary_spec.rb'
    - 'spec/lib/gitlab/cycle_analytics/usage_data_spec.rb'
    - 'spec/lib/gitlab/data_builder/note_spec.rb'
    - 'spec/lib/gitlab/database/background_migration_job_spec.rb'
    - 'spec/lib/gitlab/database_spec.rb'
    - 'spec/lib/gitlab/discussions_diff/file_collection_spec.rb'
    - 'spec/lib/gitlab/external_authorization/access_spec.rb'
    - 'spec/lib/gitlab/external_authorization/cache_spec.rb'
    - 'spec/lib/gitlab/external_authorization/logger_spec.rb'
    - 'spec/lib/gitlab/fogbugz_import/importer_spec.rb'
    - 'spec/lib/gitlab/git/branch_spec.rb'
    - 'spec/lib/gitlab/git/commit_spec.rb'
    - 'spec/lib/gitlab/git/repository_spec.rb'
    - 'spec/lib/gitlab/git_access_spec.rb'
    - 'spec/lib/gitlab/github_import/importer/diff_note_importer_spec.rb'
    - 'spec/lib/gitlab/github_import/importer/issue_importer_spec.rb'
    - 'spec/lib/gitlab/github_import/importer/issues_importer_spec.rb'
    - 'spec/lib/gitlab/github_import/importer/milestones_importer_spec.rb'
    - 'spec/lib/gitlab/github_import/importer/note_importer_spec.rb'
    - 'spec/lib/gitlab/github_import/importer/pull_request_importer_spec.rb'
    - 'spec/lib/gitlab/github_import/importer/releases_importer_spec.rb'
    - 'spec/lib/gitlab/github_import/representation/diff_note_spec.rb'
    - 'spec/lib/gitlab/github_import/representation/issue_spec.rb'
    - 'spec/lib/gitlab/github_import/representation/note_spec.rb'
    - 'spec/lib/gitlab/github_import/representation/pull_request_spec.rb'
    - 'spec/lib/gitlab/grape_logging/formatters/lograge_with_timestamp_spec.rb'
    - 'spec/lib/gitlab/grape_logging/loggers/cloudflare_logger_spec.rb'
    - 'spec/lib/gitlab/grape_logging/loggers/queue_duration_logger_spec.rb'
    - 'spec/lib/gitlab/graphql_logger_spec.rb'
    - 'spec/lib/gitlab/graphs/commits_spec.rb'
    - 'spec/lib/gitlab/import_export/project/relation_factory_spec.rb'
    - 'spec/lib/gitlab/instrumentation_helper_spec.rb'
    - 'spec/lib/gitlab/json_logger_spec.rb'
    - 'spec/lib/gitlab/lfs_token_spec.rb'
    - 'spec/lib/gitlab/log_timestamp_formatter_spec.rb'
    - 'spec/lib/gitlab/middleware/rails_queue_duration_spec.rb'
    - 'spec/lib/gitlab/omniauth_logging/json_formatter_spec.rb'
    - 'spec/lib/gitlab/phabricator_import/issues/task_importer_spec.rb'
    - 'spec/lib/gitlab/phabricator_import/representation/task_spec.rb'
    - 'spec/lib/gitlab/prometheus/queries/additional_metrics_deployment_query_spec.rb'
    - 'spec/lib/gitlab/prometheus/queries/deployment_query_spec.rb'
    - 'spec/lib/gitlab/prometheus/queries/validate_query_spec.rb'
    - 'spec/lib/gitlab/sherlock/transaction_spec.rb'
    - 'spec/lib/gitlab/sidekiq_logging/json_formatter_spec.rb'
    - 'spec/lib/gitlab/sidekiq_middleware/duplicate_jobs/strategies/until_executing_spec.rb'
    - 'spec/lib/gitlab/updated_notes_paginator_spec.rb'
    - 'spec/lib/gitlab/utils/json_size_estimator_spec.rb'
    - 'spec/lib/gitlab/x509/signature_spec.rb'
    - 'spec/lib/grafana/time_window_spec.rb'
    - 'spec/lib/json_web_token/hmac_token_spec.rb'
    - 'spec/lib/rspec_flaky/flaky_example_spec.rb'
    - 'spec/lib/rspec_flaky/listener_spec.rb'
    - 'spec/lib/rspec_flaky/report_spec.rb'

RSpec/TimecopFreeze:
  Exclude:
    - 'ee/spec/controllers/admin/application_settings_controller_spec.rb'
    - 'ee/spec/controllers/projects/security/network_policies_controller_spec.rb'
    - 'ee/spec/features/admin/admin_reset_pipeline_minutes_spec.rb'
    - 'ee/spec/features/boards/sidebar_spec.rb'
    - 'ee/spec/features/groups/analytics/cycle_analytics/filters_and_data_spec.rb'
    - 'ee/spec/features/groups/iteration_spec.rb'
    - 'ee/spec/features/projects/mirror_spec.rb'
    - 'ee/spec/features/projects/services/prometheus_custom_metrics_spec.rb'
    - 'ee/spec/finders/productivity_analytics_finder_spec.rb'
    - 'ee/spec/frontend/fixtures/analytics.rb'
    - 'ee/spec/helpers/vulnerabilities_helper_spec.rb'
    - 'ee/spec/lib/analytics/merge_request_metrics_refresh_spec.rb'
    - 'ee/spec/lib/analytics/productivity_analytics_request_params_spec.rb'
    - 'ee/spec/lib/ee/gitlab/background_migration/populate_vulnerability_historical_statistics_spec.rb'
    - 'ee/spec/lib/gitlab/analytics/cycle_analytics/data_collector_spec.rb'
    - 'ee/spec/lib/gitlab/analytics/cycle_analytics/group_stage_time_summary_spec.rb'
    - 'ee/spec/lib/gitlab/analytics/cycle_analytics/summary/group/stage_time_summary_spec.rb'
    - 'ee/spec/lib/gitlab/analytics/type_of_work/tasks_by_type_spec.rb'
    - 'ee/spec/lib/gitlab/auth/group_saml/sso_enforcer_spec.rb'
    - 'ee/spec/lib/gitlab/database/load_balancing/host_spec.rb'
    - 'ee/spec/lib/gitlab/geo/base_request_spec.rb'
    - 'ee/spec/lib/gitlab/geo/event_gap_tracking_spec.rb'
    - 'ee/spec/lib/gitlab/geo/git_push_http_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/daemon_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/events/repository_updated_event_spec.rb'
    - 'ee/spec/lib/gitlab/geo/oauth/login_state_spec.rb'
    - 'ee/spec/lib/gitlab/insights/reducers/count_per_period_reducer_spec.rb'
    - 'ee/spec/lib/gitlab/prometheus/queries/additional_metrics_environment_query_spec.rb'
    - 'ee/spec/lib/gitlab/prometheus/queries/cluster_query_spec.rb'
    - 'ee/spec/migrations/populate_vulnerability_historical_statistics_for_year_spec.rb'
    - 'ee/spec/migrations/remove_duplicated_cs_findings_spec.rb'
    - 'ee/spec/migrations/remove_duplicated_cs_findings_without_vulnerability_id_spec.rb'
    - 'ee/spec/migrations/schedule_fix_orphan_promoted_issues_spec.rb'
    - 'ee/spec/migrations/schedule_merge_request_any_approval_rule_migration_spec.rb'
    - 'ee/spec/migrations/schedule_populate_resolved_on_default_branch_column_spec.rb'
    - 'ee/spec/migrations/schedule_populate_vulnerability_historical_statistics_spec.rb'
    - 'ee/spec/migrations/schedule_project_any_approval_rule_migration_spec.rb'
    - 'ee/spec/migrations/set_resolved_state_on_vulnerabilities_spec.rb'
    - 'ee/spec/migrations/20190926180443_schedule_epic_issues_after_epics_move_spec.rb'
    - 'ee/spec/models/analytics/cycle_analytics/group_level_spec.rb'
    - 'ee/spec/models/burndown_spec.rb'
    - 'ee/spec/models/ee/namespace_spec.rb'
    - 'ee/spec/models/geo/project_registry_spec.rb'
    - 'ee/spec/models/merge_train_spec.rb'
    - 'ee/spec/models/productivity_analytics_spec.rb'
    - 'ee/spec/models/project_spec.rb'
    - 'ee/spec/models/vulnerabilities/export_spec.rb'
    - 'ee/spec/requests/api/vulnerabilities_spec.rb'
    - 'ee/spec/services/geo/file_download_service_spec.rb'
    - 'ee/spec/services/vulnerabilities/confirm_service_spec.rb'
    - 'ee/spec/services/vulnerabilities/dismiss_service_spec.rb'
    - 'ee/spec/services/vulnerabilities/resolve_service_spec.rb'
    - 'ee/spec/services/vulnerabilities/revert_to_detected_service_spec.rb'
    - 'ee/spec/services/vulnerability_exports/export_service_spec.rb'
    - 'ee/spec/support/shared_contexts/lib/gitlab/insights/reducers/reducers_shared_contexts.rb'
    - 'qa/spec/support/repeater_spec.rb'
    - 'spec/features/users/active_sessions_spec.rb'
    - 'spec/lib/gitlab/analytics/cycle_analytics/base_query_builder_spec.rb'
    - 'spec/lib/gitlab/analytics/cycle_analytics/median_spec.rb'
    - 'spec/lib/gitlab/analytics/cycle_analytics/records_fetcher_spec.rb'
    - 'spec/lib/gitlab/auth/unique_ips_limiter_spec.rb'
    - 'spec/lib/gitlab/checks/timed_logger_spec.rb'
    - 'spec/lib/gitlab/cycle_analytics/stage_summary_spec.rb'
    - 'spec/lib/gitlab/cycle_analytics/usage_data_spec.rb'
    - 'spec/lib/gitlab/instrumentation_helper_spec.rb'
    - 'spec/lib/gitlab/omniauth_logging/json_formatter_spec.rb'
    - 'spec/lib/gitlab/puma_logging/json_formatter_spec.rb'
    - 'spec/lib/gitlab/sidekiq_logging/structured_logger_spec.rb'
    - 'spec/lib/json_web_token/hmac_token_spec.rb'
    - 'spec/lib/rspec_flaky/flaky_example_spec.rb'
    - 'spec/lib/rspec_flaky/listener_spec.rb'
    - 'spec/models/active_session_spec.rb'
    - 'spec/serializers/entity_date_helper_spec.rb'
    - 'spec/support/cycle_analytics_helpers/test_generation.rb'
    - 'spec/support/helpers/cycle_analytics_helpers.rb'
    - 'spec/support/helpers/javascript_fixtures_helpers.rb'
    - 'spec/support/shared_contexts/rack_attack_shared_context.rb'
    - 'spec/support/shared_examples/workers/concerns/reenqueuer_shared_examples.rb'
    - 'spec/workers/concerns/reenqueuer_spec.rb'
    - 'spec/workers/metrics/dashboard/prune_old_annotations_worker_spec.rb'

RSpec/TimecopTravel:
  Exclude:
    - 'ee/spec/lib/gitlab/geo/event_gap_tracking_spec.rb'
    - 'ee/spec/lib/gitlab/geo/git_push_http_spec.rb'
    - 'ee/spec/lib/gitlab/geo/jwt_request_decoder_spec.rb'
    - 'ee/spec/lib/gitlab/geo/log_cursor/daemon_spec.rb'
    - 'ee/spec/models/broadcast_message_spec.rb'
    - 'ee/spec/models/burndown_spec.rb'
    - 'qa/spec/support/repeater_spec.rb'
    - 'spec/features/users/terms_spec.rb'
    - 'spec/lib/feature_spec.rb'
    - 'spec/models/broadcast_message_spec.rb'
    - 'spec/models/concerns/issuable_spec.rb'
    - 'spec/requests/api/ci/runner/jobs_trace_spec.rb'
    - 'spec/requests/api/issues/put_projects_issues_spec.rb'
    - 'spec/support/shared_contexts/cache_allowed_users_in_namespace_shared_context.rb'
    - 'spec/support/shared_examples/requests/api/time_tracking_shared_examples.rb'
    - 'spec/support/shared_examples/workers/concerns/reenqueuer_shared_examples.rb'
    - 'spec/workers/concerns/reenqueuer_spec.rb'
    - 'spec/lib/gitlab/analytics/cycle_analytics/median_spec.rb'
